// #autoload
// #name = TeamAssetHud
// #config = TeamAssetHudOptions
// #category = ilys' Scripts
// #include = support/callback.cs
// #include = support/mission_callbacks.cs
// #include = support/team_tracker.cs
// #include = support/player_support.cs
$TeamAssetHud::Show = 1;
$TeamAssetHud::Trans = 0;
$RISDeployed = 0;
$SpikeDeployed = 0;
$ClampDeployed = 0;
$DPuDeployed = 0;
$DMoDeployed = 0;
$DCaDeployed = 0;
if(isFile("prefs/TeamAssetHud.cs")) exec("prefs/TeamAssetHud.cs");
package TeamAssetHud
{
    function clientCmdTargetGameName(%ID, %targetName)
    {
		if(%targetName $= "Deployable Station") $RISDeployed++;
		else if(%targetName $= "Spider Clamp Turret") $ClampDeployed++;
		else if(%targetName $= "Landspike Turret") $SpikeDeployed++;
		else if(%targetName $= "Deployable Pulse Sensor") $DPuDeployed++;
		else if(%targetName $= "Deployable Motion Sensor") $DMoDeployed++;
		else if(%targetName $= "Deployed Camera") $DCaDeployed++;
	}
	function OptionsDlg::onWake(%this)
	{
		if (!$TeamTurretBind)
		{
			$RemapName[$RemapCount] = "Toggle AutoUpdate";
			$RemapCmd[$RemapCount]  = "ToggleAutoUpdateTAH";
			$RemapCount++;
			$TeamTurretBind = true;
		}
		parent::onWake(%this);
	}
	function quit()
	{
		export("$TeamAssetHud::*", "prefs/TeamAssetHud.cs", false);
		parent::quit();
	}
	function PlayGui::onWake(%this)
	{
		Callback.add(MyTeamChanged, "ClearHud");
		Callback.add(MyTeamChanged, "AutoUpdateTAH");
		Callback.add(onMatchStart, "ClearHud");
		Callback.add(onMatchStart, "AutoUpdateTAH");
		Callback.add(CallBackMsgGameOver, "ClearHud");
		Callback.add(onUserClientDrop, "ClearHud");
		Callback.add(onUserClientJoin, "ClearHud");
		parent::onWake(%this);
		if(!isObject(PlayGui)) return;
		if(isObject(TAHCountHud)) return;
		new GuiControlProfile ("TAHLGText")
		{
			fontType = "Univers Condensed";
			fontSize = 16;
			fontColor = "0 255 0";
			justify = "center";
		};
		new GuiControlProfile ("TAHLRText")
		{
			fontType = "Univers Condensed";
			fontSize = 16;
			fontColor = "255 0 0";
			justify = "center";
		};
		new ShellFieldCtrl(TAHCountHud)
		{
			horizSizing = "left";
			vertSizing = "bottom";
			extent = "135 40";
			visible = "1";
			new GuiBitmapCtrl() {
				horizSizing = "right";
				vertSizing = "bottom";
				position = "5 5";
				extent = "15 15";
				minExtent = "8 8";
				visible = "1";
				bitmap = "gui/rinv.png";
			};
			new GuiTextCtrl(TAHRIS)
			{
				profile = "TAHLGText";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "5 20";
				extent = "15 16 ";
				text = "0";
				visible = "1";
			};
			new GuiBitmapCtrl() {
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 5";
				extent = "15 15";
				minExtent = "8 8";
				visible = "1";
				bitmap = "gui/clamp.png";
			};
			new GuiTextCtrl(TAHClamp)
			{
				profile = "TAHLGText";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 20";
				extent = "15 16 ";
				text = "0";
				visible = "1";
			};
			new GuiBitmapCtrl() {
				horizSizing = "right";
				vertSizing = "bottom";
				position = "35 5";
				extent = "15 15";
				minExtent = "8 8";
				visible = "1";
				bitmap = "gui/spike.png";
			};
			new GuiTextCtrl(TAHSpike)
			{
				profile = "TAHLGText";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "35 20";
				extent = "15 16 ";
				text = "0";
				visible = "1";
			};
			new GuiBitmapCtrl() {
				horizSizing = "right";
				vertSizing = "bottom";
				position = "50 5";
				extent = "15 15";
				minExtent = "8 8";
				visible = "1";
				bitmap = "gui/pulse.png";
			};
			new GuiTextCtrl(TAHPulse)
			{
				profile = "TAHLGText";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "50 20";
				extent = "15 16 ";
				text = "0";
				visible = "1";
			};
			new GuiBitmapCtrl() {
				horizSizing = "right";
				vertSizing = "bottom";
				position = "65 5";
				extent = "15 15";
				minExtent = "8 8";
				visible = "1";
				bitmap = "gui/motion.png";
			};
			new GuiTextCtrl(TAHMotion)
			{
				profile = "TAHLGText";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "65 20";
				extent = "15 16 ";
				text = "0";
				visible = "1";
			};
			new GuiBitmapCtrl() {
				horizSizing = "right";
				vertSizing = "bottom";
				position = "80 5";
				extent = "15 15";
				minExtent = "8 8";
				visible = "1";
				bitmap = "gui/camera.png";
			};
			new GuiTextCtrl(TAHCamera)
			{
				profile = "TAHLGText";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "80 20";
				extent = "15 16 ";
				text = "0";
				visible = "1";
			};
			new GuiTextCtrl() {
				profile = "TAHLRText";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "100 5";
				extent = "30 16";
				text = "AUTO";
				visible = "1";
			};
			new GuiTextCtrl(AutoUpdateText)
			{
				profile = "TAHLGText";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "100 20";
				extent = "30 16 ";
				text = "OFF";
				visible = "1";
			};
		};
		TAHCountHud.profile = $TeamAssetHud::Trans ? "GuiConsoleProfile" : "GuiChatBackProfile";
		playGui.add(TAHCountHud);
		if(isObject(HM) && isObject(HudMover)) hudmover::addhud(TAHCountHud,"TeamAssetHud");
	}
};
activatePackage(TeamAssetHud);
function MakeFindItemCC()
{
	if(CommanderTree.getGroup() == CommanderTreeContainer.getObject(0) && canvas.getContent().getName() !$= "CommanderMapGui")
	{
		PlayGui.add(FindItemCC);
		FindItemCC.add(CommanderTree);
		CommanderTree.openCategory("DSupport",1);
		CommanderTree.openCategory("DTactical",1);
		CommanderTree.openCategory("Tactical",1);
		commandToServer('ScopeCommanderMap', true);
	}
}
function KillFindItemCC()
{
	if(CommanderTree.getGroup() == FindItemCC.getID())
	{
		PlayGui.remove(FindItemCC);
		CommanderTreeContainer.getObject(0).add(CommanderTree);
		commandToServer('ScopeCommanderMap', false);
	}
}
function FindItems(%item)
{
	$MAX_OUTSTANDING_TASKS = 512;
	$ID = commanderTree.getTarget(%item,$SpamID);
	ServerConnection.sendTargetToServer($ID, "0 0 0");
	commandToServer('GetTargetGameName',$ID);
	$SpamID++;
	if($SpamID < commanderTree.getNumTargets(%item)) schedule(200,0,FindItems,%item);
	else $SpamID = 0;
}
function ToggleAutoUpdateTAH(%val)
{
	if(%val)
	{
		$TeamAssetFinder::AutoUpdateTAH = !$TeamAssetFinder::AutoUpdateTAH;
		AutoUpdateText.setValue($TeamAssetFinder::AutoUpdateTAH ? "ON" : "OFF");
		if($TeamAssetFinder::AutoUpdateTAH)
		{
			clientCmdBottomPrint("AutoUpdate is now: On", 2, 1);
			AutoUpdateTAH();
		}
		else
		{
			clientCmdBottomPrint("AutoUpdate is now: Off", 2, 1);
			cancel($AutoWPAssetSchedule);
			ClearHud();
		}
	}
}
function AutoUpdateTAH()
{
	cancel($AutoUpdateTAHchedule);
	AutoUpdateText.setValue($TeamAssetFinder::AutoUpdateTAH ? "ON" : "OFF");
	if(!$TeamAssetFinder::AutoUpdateTAH) return;
	if(teamtracker.friendlyteamid == 0) return;
	ClearStats();
	MakeFindItemCC();
	schedule(250,0,AutoUpdateTAHSecond);
}
function AutoUpdateTAHSecond()
{
	FindItems(DSupport);
	schedule(250*commanderTree.getNumTargets(DSupport),0,FindItems,DTactical);
	schedule((250*commanderTree.getNumTargets(DTactical))+(250*commanderTree.getNumTargets(DSupport)),0,UpdateTAHHud);
	$AutoUpdateTAHchedule = schedule((250*commanderTree.getNumTargets(DTactical))+(250*commanderTree.getNumTargets(DSupport))+500,0,AutoUpdateTAH);
}
function UpdateTAHHud()
{
	KillFindItemCC();
	TAHRIS.setValue($RISDeployed);
	TAHSpike.setValue($SpikeDeployed);
	TAHClamp.setValue($ClampDeployed);
	TAHPulse.setValue($DPuDeployed);
	TAHMotion.setValue($DMoDeployed);
	TAHCamera.setValue($DCaDeployed);
}
function ClearStats()
{
	$RISDeployed = 0;
	$SpikeDeployed = 0;
	$ClampDeployed = 0;
	$DPuDeployed = 0;
	$DMoDeployed = 0;
	$DCaDeployed = 0;
}
function ClearHud()
{
	$RISDeployed = 0;
	$SpikeDeployed = 0;
	$ClampDeployed = 0;
	$DPuDeployed = 0;
	$DMoDeployed = 0;
	$DCaDeployed = 0;
	TAHRIS.setValue($RISDeployed);
	TAHSpike.setValue($SpikeDeployed);
	TAHClamp.setValue($ClampDeployed);
	TAHPulse.setValue($DPuDeployed);
	TAHMotion.setValue($DMoDeployed);
	TAHCamera.setValue($DCaDeployed);
}
function TeamAssetHudOptions::onWake(%this)
{
	TransTAHHud.setValue($TeamAssetHud::Trans);
}
new GuiControl(FindItemCC)
{
	profile = "NewScrollCtrlProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "0 0";
};
new GuiControl(TeamAssetHudOptions) {
	profile = "GuiDefaultProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "195 50";
	visible = "1";
	new ShellFieldCtrl() {
		profile = "ShellFieldProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "4 4";
		extent = "185 40";
		minExtent = "16 18";
		visible = "1";
		new ShellToggleButton(TransTAHHud) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "5 5";
			extent = "170 27";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$TeamAssetHud::Trans";
			command = "TAHCountHud.profile = $TeamAssetHud::Trans ? \"GuiConsoleProfile\" : \"GuiChatBackProfile\";";
			helpTag = "0";
			text = "Transparent Hud";
			longTextBuffer = "0";
			maxLength = "255";
		};
	};
};
